> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/caf-sdk-pt-br/android/standalone-modules/cafsmartauth/lifecycle.md).

# Ciclo de vida do SDK

## CafVerifyPolicyListener

O `CafVerifyPolicyListener` a interface lida com eventos principais durante a autenticação do SDK:

| Evento                                                                     | Descrição                                                            |
| -------------------------------------------------------------------------- | -------------------------------------------------------------------- |
| onCancel()                                                                 | Disparado quando o usuário cancela o processo.                       |
| onError(failure: CafFailure)                                               | Chamado em caso de falha do SDK, com os detalhes do erro fornecidos. |
| onPending(isAuthorized: Boolean, attestation: String)                      | Chamado quando o SDK está aguardando um resultado.                   |
| onLoaded()                                                                 | Disparado quando o SDK conclui uma operação.                         |
| onLoading()                                                                | Indica que o SDK está iniciando uma operação.                        |
| onSuccess(isAuthorized: Boolean, attemptId: String?, attestation: String?) | Chamado após uma detecção bem-sucedida, com o resultado fornecido.   |

### Exemplo

```kotlin
    private fun setupListener() = object : CafVerifyPolicyListener {
        override fun onSuccess(
            isAuthorized: Boolean,
            attemptId: String?,
            attestation: String?
        ) {
            println("CafVerifyPolicyListener.onSuccess isAuthorized: $isAuthorized")
            println("CafVerifyPolicyListener.onSuccess attemptId: $attemptId")
            println("CafVerifyPolicyListener.onSuccess attestation: $attestation")
        }

        override fun onPending(isAuthorized: Boolean, attestation: String) {
            println("CafVerifyPolicyListener.onPending isAuthorized: $isAuthorized")
            println("CafVerifyPolicyListener.onPending attestation: $attestation")
        }

        override fun onError(failure: CafFailure) {
            println("CafVerifyPolicyListener.onError failure: ${failure.message}")
        }

        override fun onCancel() {
            println("CafVerifyPolicyListener.onCancel")
        }

        override fun onLoading() {
            println("CafVerifyPolicyListener.onLoading")
        }

        override fun onLoaded() {
            println("CafVerifyPolicyListener.onLoaded")
        }
    }
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/caf-sdk-pt-br/android/standalone-modules/cafsmartauth/lifecycle.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
